=== mcs/class/Mono.Management/Makefile ===
thisdir = class/Mono.Management
SUBDIRS =
include ../../build/rules.make

LIBRARY = Mono.Management.dll

LIB_REFS = System Mono.Posix
KEYFILE = ../mono.pub
LIB_MCS_FLAGS =
NO_TEST = yes

include ../../build/library.make
