=== debian/changelog ===
mono (6.12.0.199+ds-4) unstable; urgency=medium

  [ Ahmad Khalifa ]
  * d/salsa-ci: Add working salsa ci config.
    (Closes: #1108323)

  [ Antoine Le Gonidec ]
  * Add a NEWS entry about the merge of libmono-*-cil packages.
  * Fix libmono-corlib4.5-cil Breaks/Provides/Replaces (again).
    (Closes: #1108110)
  * Update maintainer e-mail.
  * Drop git-buildpackage configuration.

 -- Antoine Le Gonidec <vv221@debian.org>  Sun, 10 Aug 2025 20:07:02 +0200

mono (6.12.0.199+ds-3) experimental; urgency=medium

  [ Antoine Le Gonidec ]
  * Fix build on arch: any.
  * Move upstream source changes to debian/patches.
  * Use a fixed build date in binaries.
  * Do not rely on a hardcoded path for update-binfmts in maintainer scripts.
  * Bump Standards-Version to 4.7.2.
  * Fix libmono-corlib4.5-cil Breaks/Provides/Replaces.
    (Closes: #1108110)

 -- Antoine Le Gonidec <debian@vv221.fr>  Tue, 24 Jun 2025 01:38:18 +0200

mono (6.12.0.199+ds-2) experimental; urgency=medium

  [ Ahmad Khalifa ]
  * d/rules: cleanup variables and repacking target.
  * d/rules: Cleanup build options, minimise arch flags.
  * d/rules: move manpage copying to sym links instead.
  * Fix d/copyright formatting and naming.
  * Fix lintian errors.
  * d/tests: Add basic autopkgtest for runtime and compiler.
  * Upgrade dh compat from 10 to 13.
    (Closes: #1107836)
  * Consolidate CIL packages into libmono-corlib4.5-cil.
    (Closes: #1107838)

  [ Clint Adams ]
  * debian/mono-api-check: use mktemp instead of tempfile.

 -- Antoine Le Gonidec <debian@vv221.fr>  Mon, 16 Jun 2025 12:08:54 +0200

mono (6.12.0.199+ds-1) experimental; urgency=medium

  [ Ahmad Khalifa ]
  * Improve upstream repacking with Files-Excluded.
    (Closes: #1106868)

 -- Antoine Le Gonidec <debian@vv221.fr>  Sat, 31 May 2025 21:14:45 +0200

mono (6.12.0.199+dfsg-6) unstable; urgency=medium

  * Drop obsolete Breaks/Replaces from mono-devel.

 -- Antoine Le Gonidec <debian@vv221.fr>  Thu, 03 Apr 2025 15:46:50 +0200

mono (6.12.0.199+dfsg-5) unstable; urgency=medium

  * Prevent the inclusion of debug symbols in libmono-btls-interface4.0-cil.
    (Closes: #1101768)
  * Tweak the description of libmono-corlib4.5-cil and libmono-corlib4.5-dll.
  * Update lintian overrides.

 -- Antoine Le Gonidec <debian@vv221.fr>  Mon, 31 Mar 2025 21:01:03 +0200

mono (6.12.0.199+dfsg-4) unstable; urgency=medium

  * Include upstream patch disabling 32-bit float operations when unsupported
    (Closes: #1098958)
  * Improve mastersummary.xml reproducibility
    (Closes: #1010854)
  * Improve Multi-Arch metadata.
  * Update Maintainer email.

 -- Antoine Le Gonidec <debian@vv221.fr>  Mon, 24 Mar 2025 13:16:01 +0100
