=== debian/tests/control ===
Tests: test-runtime
Depends: mono-runtime, mono-utils
Restrictions: allow-stderr

Tests: test-devel
Depends: mono-csharp-shell, mono-devel, mono-runtime, mono-utils
Restrictions: allow-stderr
