=== debian/watch ===
version=4
opts=dversionmangle=s/\+ds//,repacksuffix=+ds,compression=xz \
	http://download.mono-project.com/sources/mono/mono-([\d\.]+)\.tar\.xz
